export function MonacoExcludeLanguages(esbuild) {
	if(esbuild){
		return {
			name: 'esbuild-plugin-monaco-exclude-languages',
			setup(build){
				build.onLoad({ filter:  /basic-languages[/\\]monaco\.contribution\.js/ }, async (args) => {
					console.log(args)
					return {
						contents: `import '../editor/editor.api.js';`,
						loader: 'ts'
					}
				})
			}
		}
	}
	return {
		name: 'rollup-plugin-monaco-exclude-languages',
		load(path){
			if(/basic-languages[/\\]monaco\.contribution\.js/.test(path)){
				return `import '../editor/editor.api.js';`
			}
		}
	}
}